﻿Public Class Form1

    Dim dtpCalendario As New DateTimePicker

    Private Sub btnVincularDados_Click(sender As Object, e As EventArgs) Handles btnVincularDados.Click

        With dgvDados
            'permite adicionar e deletar linhas
            .AllowUserToAddRows = False
            .AllowUserToDeleteRows = False
            'ajusta a largura das colunas
            .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            'ajusta as colunas ao conteúdo das células
            .AutoResizeColumns()
            'define o numero de colunas 
            .ColumnCount = 3
            'define os nomes das colunas
            .Columns(0).Name = "Produto ID"
            .Columns(1).Name = "Nome do Produto"
            .Columns(2).Name = "Data do Produto"
        End With

        'define linhas de dados para exibir no datagridview
        Dim linha As String() = New String() {"1", "Tablet IPad", Now()}
        dgvDados.Rows.Add(linha)
        linha = New String() {"2", "SmartPhone ", Now().AddDays(3)}
        dgvDados.Rows.Add(linha)
        linha = New String() {"3", "Teclado ", Now().AddDays(1)}
        dgvDados.Rows.Add(linha)
        linha = New String() {"4", "Monitor ", Now()}
        dgvDados.Rows.Add(linha)
        linha = New String() {"5", "Mouse ótico ", Now()}
        dgvDados.Rows.Add(linha)

        btnAdicionaButton.Enabled = True

    End Sub

    Private Sub btnAdicionaButton_Click(sender As Object, e As EventArgs) Handles btnAdicionaButton.Click
        'define uma classe do tipo DataGridViewButtonColumn()
        Dim btn As New DataGridViewButtonColumn()
        'adiciona o button na coluna
        dgvDados.Columns.Add(btn)
        'define o texto, o nome e a largura do botão
        With btn
            .HeaderText = ""
            .Text = "Deletar"
            .Name = "btnDeletaLinha"
            'exibe o texto no botão
            .UseColumnTextForButtonValue = True
            .Width = 80
        End With
    End Sub

    Private Sub dgvDados_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvDados.CellClick
        Select Case e.ColumnIndex
            Case 2
                '//adiciona o controle DateTimePicker no DataGridView
                dgvDados.Controls.Add(dtpCalendario)

                '// Define o formato da data ( 02/07/2017 - dd/MM/yyyy)
                dtpCalendario.Format = DateTimePickerFormat.Short

                '// Retorna a área retangular que representa a área de exibição para a célula
                Dim oRectangle = dgvDados.GetCellDisplayRectangle(e.ColumnIndex, e.RowIndex, True)

                '//Define a área para o controle DateTimePicker
                dtpCalendario.Size = New Size(oRectangle.Width, oRectangle.Height)

                '//Define a localização
                dtpCalendario.Location = New Point(oRectangle.X, oRectangle.Y)
                '// Le o valor da célula do DataGridView par ao DateTimePicker
                dtpCalendario.Value = dgvDados.CurrentCell.Value
                '// Torna o datetimepicker visivel
                dtpCalendario.Visible = True
                '// Força a alteração do valor da data no evento dtpCalendario_ValueChanged
                AddHandler dtpCalendario.ValueChanged, AddressOf dtpCalendario_ValueChanged

            Case 3
                'obtem o nome da coluna
                Dim nomeColuna As String = dgvDados.Columns(e.ColumnIndex).Name
                'verifica se a coluna é a coluna do botão 
                If nomeColuna = "btnDeletaLinha" Then
                    '// Deleta a linha atual do DataGridView1
                    dgvDados.Rows.Remove(dgvDados.CurrentRow)
                End If
        End Select
    End Sub

    Private Sub dtpCalendario_ValueChanged(sender As Object, e As EventArgs)
        'atribui o valor do calenário na célula do datagridview
        dgvDados.CurrentCell.Value = dtpCalendario.Value
    End Sub

    Private Sub dgvDados_CellLeave(sender As Object, e As DataGridViewCellEventArgs) Handles dgvDados.CellLeave
        'oculta o calendario quando sai da célula
        dtpCalendario.Visible = False
    End Sub

    Private Sub btnEncerrar_Click(sender As Object, e As EventArgs) Handles btnEncerrar.Click
        Application.Exit()
    End Sub
End Class
